// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function PolynomialToTextDirect(p, x){
  var ll;
  var str;
  var i, c, j;
  var buffer;

  buffer = {};

  ll = CreateLinkedListCharacter();

  if(p.length == 0){
    LinkedListAddCharacter(ll, '0');
  }else{
    for(i = 0; i < p.length; i = i + 1){
      c = p[i];
      if(c < 0){
        LinkedListAddCharacter(ll, '-');
      }else{
        LinkedListAddCharacter(ll, '+');
      }

      nCreateStringFromNumberWithCheck(Math.abs(c), 10, buffer);
      LinkedListCharactersAddString(ll, buffer.string);
      delete(buffer.string);

      LinkedListCharactersAddString(ll, x);
      LinkedListAddCharacter(ll, '^');

      nCreateStringFromNumberWithCheck(i, 10, buffer);
      LinkedListCharactersAddString(ll, buffer.string);
      delete(buffer.string);
    }
  }

  str = LinkedListCharactersToArray(ll);
  FreeLinkedListCharacter(ll);

  return str;
}
function GenerateCommonRenderSpecification(p, showCoefficient, sign, coefficient, showPower, showX){
  var i, zeros, c;
  var setZero;

  setZero = false;

  if(p.length == 0){
    setZero = true;
  }else{
    zeros = 0;
    for(i = 0; i < p.length; i = i + 1){
      if(p[i] == 0){
        zeros = zeros + 1;
      }
    }

    if(zeros == p.length){
      setZero = true;
    }else{
      showCoefficient.booleanArray = [];
      showCoefficient.booleanArray.length = p.length;
      sign.string = [];
      sign.string.length = p.length;
      coefficient.numberArray = [];
      coefficient.numberArray.length = p.length;
      showPower.booleanArray = [];
      showPower.booleanArray.length = p.length;
      showX.booleanArray = [];
      showX.booleanArray.length = p.length;

      for(i = 0; i < p.length; i = i + 1){
        c = p[i];

        if(c < 0){
          sign.string[i] = '-';
        }else{
          sign.string[i] = '+';
        }
        coefficient.numberArray[i] = Math.abs(p[i]);
        if(c == 0){
          showCoefficient.booleanArray[i] = false;
        }else{
if(Math.abs(c) == 1 && i > 0){
            showCoefficient.booleanArray[i] = false;
          }else{
            showCoefficient.booleanArray[i] = true;
          }

          if(i == 0){
            showX.booleanArray[i] = false;
            showPower.booleanArray[i] = false;
          }else{
            showX.booleanArray[i] = true;
            if(i == 1){
              showPower.booleanArray[i] = false;
            }else{
              showPower.booleanArray[i] = true;
            }
          }
        }
      }
    }
  }

  if(setZero){
    showCoefficient.booleanArray = [];
    showCoefficient.booleanArray.length = 1;
    sign.string = [];
    sign.string.length = 1;
    coefficient.numberArray = [];
    coefficient.numberArray.length = 1;
    showPower.booleanArray = [];
    showPower.booleanArray.length = 1;
    showX.booleanArray = [];
    showX.booleanArray.length = 1;

    showCoefficient.booleanArray[0] = true;
    sign.string[0] = '+';
    coefficient.numberArray[0] = 0;
    showPower.booleanArray[0] = true;
    showX.booleanArray[0] = false;
  }
}
function PolynomialToText(p, x){
  var ll;
  var str;
  var i, c;
  var buffer;
  var showCoefficient, showPower, showX;
  var sign;
  var coefficient;
  var hasPrinted;

  showCoefficient = CreateBooleanArrayReferenceLengthValue(0, false);
  showPower = CreateBooleanArrayReferenceLengthValue(0, false);
  showX = CreateBooleanArrayReferenceLengthValue(0, false);
  sign = CreateStringReferenceLengthValue(0, ' ');
  coefficient = CreateNumberArrayReferenceLengthValue(0, 0);

  GenerateCommonRenderSpecification(p, showCoefficient, sign, coefficient, showPower, showX);

  buffer = CreateStringReferenceLengthValue(0, ' ');

  ll = CreateLinkedListCharacter();

  hasPrinted = false;
  for(i = 0; i < showCoefficient.booleanArray.length; i = i + 1){
    c = p[i];

    if(showCoefficient.booleanArray[i] || showX.booleanArray[i]){
      if( !hasPrinted  && c >= 0){
      }else{
        LinkedListAddCharacter(ll, sign.string[i]);
      }

      if(showCoefficient.booleanArray[i]){
        nCreateStringFromNumberWithCheck(coefficient.numberArray[i], 10, buffer);
        LinkedListCharactersAddString(ll, buffer.string);
        delete(buffer.string);
        hasPrinted = true;
      }

      if(showX.booleanArray[i]){
        LinkedListCharactersAddString(ll, x);
        hasPrinted = true;
        if(showPower.booleanArray[i]){
          LinkedListAddCharacter(ll, '^');
          nCreateStringFromNumberWithCheck(i, 10, buffer);
          LinkedListCharactersAddString(ll, buffer.string);
          delete(buffer.string);
        }
      }
    }
  }

  str = LinkedListCharactersToArray(ll);
  FreeLinkedListCharacter(ll);

  return str;
}
function ComplexPolynomialToTextDirect(p, x){
  var ll;
  var str, number;
  var i;
  var c;
  var buffer;

  buffer = {};

  ll = CreateLinkedListCharacter();

  if(p.cs.length == 0){
    LinkedListAddCharacter(ll, '0');
  }else{
    for(i = 0; i < p.cs.length; i = i + 1){
      c = p.cs[i];
      if(i > 0){
        LinkedListAddCharacter(ll, '+');
      }

      number = cComplexToString(c);
      LinkedListAddCharacter(ll, '(');
      LinkedListCharactersAddString(ll, number);
      LinkedListAddCharacter(ll, ')');
      delete(number);

      LinkedListCharactersAddString(ll, x);
      LinkedListAddCharacter(ll, '^');

      nCreateStringFromNumberWithCheck(i, 10, buffer);
      LinkedListCharactersAddString(ll, buffer.string);
      delete(buffer.string);
    }
  }

  str = LinkedListCharactersToArray(ll);
  FreeLinkedListCharacter(ll);

  return str;
}
function Add(a, b){
  var i, nr;

  nr = b.length;

  for(i = 0; i < nr; i = i + 1){
    a[i] = a[i] + b[i];
  }
}
function Subtract(a, b){
  var i, nr;

  nr = b.length;

  for(i = 0; i < nr; i = i + 1){
    a[i] = a[i] - b[i];
  }
}
function Multiply(c, a, b){
  var k, n, m, i;
  var av, bv;

  n = Degree(a);
  m = Degree(b);

  Fill(c, 0);

  for(i = 0; i <= n + m; i = i + 1){
    c[i] = 0;
    for(k = 0; k <= i && k < a.length && i - k < b.length; k = k + 1){
      av = a[k];
      bv = b[i - k];
      c[i] = c[i] + av*bv;
    }
  }
}
function Divide(q, r, n, d){
  var t, t1;
  var tcoff, tdegree, i;
  var deg;
  var rd, dd;

  Fill(q, 0);
  Assign(r, n);
  deg = Degree(n);
  t = CreatePolynomial(deg);
  t1 = CreatePolynomial(deg);

  rd = Degree(r);
  dd = Degree(d);
  for(i = 0; i < deg + 1 &&  !IsZero(r)  && rd - i >= dd; i = i + 1){
    Fill(t, 0);
    tdegree = rd - i - dd;
    tcoff = r[rd - i]/d[dd];
    t[tdegree] = tcoff;
    Add(q, t);
    Fill(t1, 0);
    Multiply(t1, t, d);
    Subtract(r, t1);
  }

  delete(t);
  delete(t1);
}
function IsZero(a){
  var i;
  var itIsZero;

  itIsZero = true;

  for(i = 0; i < a.length; i = i + 1){
    if(a[i] != 0){
      itIsZero = false;
    }
  }

  return itIsZero;
}
function Assign(a, b){
  var i, nr;

  nr = b.length;

  for(i = 0; i < nr; i = i + 1){
    a[i] = b[i];
  }
}
function CreatePolynomial(deg){
  var p;

  p = [];
  p.length = deg + 1;

  Fill(p, 0);

  return p;
}
function Fill(p, value){
  var i;

  for(i = 0; i < p.length; i = i + 1){
    p[i] = value;
  }
}
function Degree(A){
  var i;
  var deg;
  var done;

  done = false;
  deg = 0;
  for(i = A.length - 1; i >= 0 &&  !done ; i = i - 1){
    if(A[i] != 0){
      deg = i;
      done = true;
    }
  }

  return deg;
}
function Lead(A){
  var deg;

  deg = Degree(A);

  return A[deg];
}
function Evaluate(A, x){
  return EvaluateWithHornersMethod(A, x);
}
function EvaluateWithHornersMethod(A, x){
  var r, i;

  r = 0;

  for(i = A.length - 1; i >= 0; i = i - 1){
    r = r*x;
    r = A[i] + r;
  }

  return r;
}
function EvaluateWithPowers(A, x){
  var r, i;

  r = 0;

  for(i = 0; i < A.length; i = i + 1){
    r = r + A[i]*Math.pow(x, i);
  }

  return r;
}
function EvaluateDerivative(A, x, n){
  var r, i, v;

  r = 0;

  for(i = 0; i < A.length; i = i + 1){
    if(i - n >= 0){
      v = A[i]*mPermutations(i, n)*Math.pow(x, i - n);
      r = r + v;
    }
  }

  return r;
}
function Derivative(A){
  var i, degree;

  degree = 0;
  for(i = 1; i < A.length; i = i + 1){
    degree = degree + 1;
    A[i - 1] = degree*A[i];
  }

  A[A.length - 1] = 0;
}
function AddComplex(a, b){
  var i, nr;

  nr = a.cs.length;

  for(i = 0; i < nr; i = i + 1){
    cAdd(a.cs[i], b.cs[i]);
  }
}
function SubtractComplex(a, b){
  var i, nr;

  nr = a.cs.length;

  for(i = 0; i < nr; i = i + 1){
    cSub(a.cs[i], b.cs[i]);
  }
}
function IsZeroComplex(a){
  var i;
  var itIsZero;

  itIsZero = true;

  for(i = 0; i < a.cs.length; i = i + 1){
    if(a.cs[i].re != 0 && a.cs[i].im != 0){
      itIsZero = false;
    }
  }

  return itIsZero;
}
function AssignComplex(a, b){
  var i, nr;

  nr = b.cs.length;

  for(i = 0; i < nr; i = i + 1){
    cAssignComplex(a.cs[i], b.cs[i]);
  }
}
function CreateComplexPolynomial(deg){
  var p;
  var i;

  p = {};
  p.cs = [];
  p.cs.length = deg + 1;

  for(i = 0; i < deg + 1; i = i + 1){
    p.cs[i] = {};
  }

  FillComplex(p, 0, 0);

  return p;
}
function FillComplex(p, re, im){
  var i;
  var c;

  c = cCreateComplexNumber(re, im);

  for(i = 0; i < p.cs.length; i = i + 1){
    cAssignComplex(p.cs[i], c);
  }

  delete(c);
}
function DegreeComplex(A){
  var i;
  var deg;
  var done;

  done = false;
  deg = 0;
  for(i = A.cs.length - 1; i >= 0 &&  !done ; i = i - 1){
    if(A.cs[i].re != 0 && A.cs[i].im != 0){
      deg = i;
      done = true;
    }
  }

  return deg;
}
function LeadComplex(A){
  var deg;

  deg = DegreeComplex(A);

  return A.cs[deg];
}
function EvaluateComplex(A, x){
  var i;
  var r, t;

  r = cCreateComplexNumber(0, 0);
  t = cCreateComplexNumber(0, 0);

  for(i = 0; i < A.cs.length; i = i + 1){
    cAssignComplex(t, x);
    cPower(t, i);
    cMul(t, A.cs[i]);
    cAdd(r, t);
  }

  return r;
}
function TotalNumberOfRoots(p){
  return Degree(p);
}
function testRendering(failures){
  var p;
  var str;
  var cp;

  p = nStringToNumberArray("-42, -12, 0, 1".split(''));

  str = PolynomialToTextDirect(p, "x".split(''));
  AssertStringEquals(str, "-42x^0-12x^1+0x^2+1x^3".split(''), failures);

  str = PolynomialToText(p, "x".split(''));
  AssertStringEquals(str, "-42-12x+x^3".split(''), failures);

  p = nStringToNumberArray("0, 0".split(''));

  str = PolynomialToTextDirect(p, "x".split(''));
  AssertStringEquals(str, "+0x^0+0x^1".split(''), failures);

  str = PolynomialToText(p, "x".split(''));
  AssertStringEquals(str, "0".split(''), failures);

  p = nStringToNumberArray("-1, -1".split(''));

  str = PolynomialToTextDirect(p, "x".split(''));
  AssertStringEquals(str, "-1x^0-1x^1".split(''), failures);

  str = PolynomialToText(p, "x".split(''));
  AssertStringEquals(str, "-1-x".split(''), failures);

  p = nStringToNumberArray("1, 1, 1".split(''));

  str = PolynomialToTextDirect(p, "x".split(''));
  AssertStringEquals(str, "+1x^0+1x^1+1x^2".split(''), failures);

  str = PolynomialToText(p, "x".split(''));
  AssertStringEquals(str, "1+x+x^2".split(''), failures);

  p = nStringToNumberArray("0, 0, 2".split(''));

  str = PolynomialToTextDirect(p, "x".split(''));
  AssertStringEquals(str, "+0x^0+0x^1+2x^2".split(''), failures);

  str = PolynomialToText(p, "x".split(''));
  AssertStringEquals(str, "2x^2".split(''), failures);

  p = nStringToNumberArray("0, 0, -2".split(''));
  str = PolynomialToText(p, "x".split(''));
  AssertStringEquals(str, "-2x^2".split(''), failures);

  cp = CreateComplexPolynomial(3);
  cAssignComplexByValues(cp.cs[0],  -5, 1);
  cAssignComplexByValues(cp.cs[1], 3, 2);
  cAssignComplexByValues(cp.cs[2],  -3,  -3);
  cAssignComplexByValues(cp.cs[3], 1, 4);

  str = ComplexPolynomialToTextDirect(cp, "x".split(''));
  AssertStringEquals(str, "(-5+1i)x^0+(3+2i)x^1+(-3-3i)x^2+(1+4i)x^3".split(''), failures);
}
function testDivision(failures){
  var p1, p2, q, r, aq, ar;
  var i;

  p1 = nStringToNumberArray("-4, 0, -2, 1".split(''));
  p2 = nStringToNumberArray("-3, 1, 0, 0".split(''));

  q = CreatePolynomial(6);
  r = CreatePolynomial(6);

  Divide(q, r, p1, p2);

  aq = nStringToNumberArray("3, 1, 1, 0".split(''));
  ar = nStringToNumberArray("5, 0, 0, 0".split(''));

  for(i = 0; i < 4; i = i + 1){
    AssertTrue(mEpsilonCompare(q[i], aq[i], 0.000001), failures);
  }
  for(i = 0; i < 4; i = i + 1){
    AssertTrue(mEpsilonCompare(r[i], ar[i], 0.000001), failures);
  }
}
function testDivision2(failures){
  var p1, p2, q, r, aq, ar;
  var i;

  p1 = nStringToNumberArray("-42, 0, -12, 1".split(''));
  p2 = nStringToNumberArray("1, -2, 1, 0".split(''));

  q = CreatePolynomial(6);
  r = CreatePolynomial(6);

  Divide(q, r, p1, p2);

  aq = nStringToNumberArray("-10, 1, 0, 0".split(''));
  ar = nStringToNumberArray("-32, -21, 0, 0".split(''));

  for(i = 0; i < 4; i = i + 1){
    AssertTrue(mEpsilonCompare(q[i], aq[i], 0.000001), failures);
  }
  for(i = 0; i < 4; i = i + 1){
    AssertTrue(mEpsilonCompare(r[i], ar[i], 0.000001), failures);
  }
}
function testDerivative(failures){
  var p1, p2, p;
  var i, y1, y2;

  p = nStringToNumberArray("4, 0, 2, 0, -1".split(''));
  p1 = nStringToNumberArray("4, 0, 2, 0, -1".split(''));
  p2 = nStringToNumberArray("0, 4, 0, -4, 0".split(''));

  Derivative(p1);

  for(i = 0; i < 5; i = i + 1){
    AssertTrue(mEpsilonCompare(p1[i], p2[i], 0.000001), failures);
  }

  y1 = Evaluate(p, 2);
  y2 = EvaluateDerivative(p, 2, 0);

  AssertTrue(mEpsilonCompare(y1, y2, 0.000001), failures);

  y1 = Evaluate(p1, 2);
  y2 = EvaluateDerivative(p, 2, 1);

  AssertTrue(mEpsilonCompare(y1, y2, 0.000001), failures);

  Derivative(p1);

  y1 = Evaluate(p1, 2);
  y2 = EvaluateDerivative(p, 2, 2);

  AssertTrue(mEpsilonCompare(y1, y2, 0.000001), failures);
}
function testEvaluation(failures){
  var p;
  var c, d, fd;
  var equals;

  p = nStringToNumberArray("-5, 3, -3, 1".split(''));

  d = Evaluate(p, 2);

  AssertEquals(d,  -3, failures);
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  testDivision(failures);
  testDivision2(failures);
  testDerivative(failures);
  testComplexEvaluation(failures);
  testEvaluation(failures);
  testRendering(failures);

  return failures.numberValue;
}
function testComplexEvaluation(failures){
  var p;
  var c, d, fd;
  var equals;

  p = CreateComplexPolynomial(3);
  cAssignComplexByValues(p.cs[0],  -5, 0);
  cAssignComplexByValues(p.cs[1], 3, 0);
  cAssignComplexByValues(p.cs[2],  -3, 0);
  cAssignComplexByValues(p.cs[3], 1, 0);

  c = cCreateComplexNumber(0.4, 0.9);
  fd = cCreateComplexNumber( -2.758, 0.243);

  d = EvaluateComplex(p, c);

  equals = cEpsilonCompareComplex(d, fd, 0.01);

  AssertTrue(equals, failures);
}
function mNegate(x){
  return  -x;
}
function mPositive(x){
  return  +x;
}
function mFactorial(x){
  var i, f;

  f = 1;

  for(i = 2; i <= x; i = i + 1){
    f = f*i;
  }

  return f;
}
function mRound(x){
  return Math.floor(x + 0.5);
}
function mBankersRound(x){
  var r;

  if(mAbsolute(x - mTruncate(x)) == 0.5){
    if( !mDivisibleBy(mRound(x), 2) ){
      r = mRound(x) - 1;
    }else{
      r = mRound(x);
    }
  }else{
    r = mRound(x);
  }

  return r;
}
function mCeil(x){
  return Math.ceil(x);
}
function mFloor(x){
  return Math.floor(x);
}
function mTruncate(x){
  var t;

  if(x >= 0){
    t = Math.floor(x);
  }else{
    t = Math.ceil(x);
  }

  return t;
}
function mAbsolute(x){
  return Math.abs(x);
}
function mLogarithm(x){
  return Math.log10(x);
}
function mNaturalLogarithm(x){
  return Math.log(x);
}
function mSin(x){
  return Math.sin(x);
}
function mCos(x){
  return Math.cos(x);
}
function mTan(x){
  return Math.tan(x);
}
function mAsin(x){
  return Math.asin(x);
}
function mAcos(x){
  return Math.acos(x);
}
function mAtan(x){
  return Math.atan(x);
}
function mAtan2(y, x){
  var a;

  /* Atan2 is an invalid operation when x = 0 and y = 0, but this method does not return errors. */
  a = 0;

  if(x > 0){
    a = mAtan(y/x);
  }else if(x < 0 && y >= 0){
    a = mAtan(y/x) + Math.PI;
  }else if(x < 0 && y < 0){
    a = mAtan(y/x) - Math.PI;
  }else if(x == 0 && y > 0){
    a = Math.PI/2;
  }else if(x == 0 && y < 0){
    a =  -Math.PI/2;
  }

  return a;
}
function mSquareroot(x){
  return Math.sqrt(x);
}
function mExp(x){
  return Math.exp(x);
}
function mDivisibleBy(a, b){
  return ((a%b) == 0);
}
function mCombinations(n, k){
  var i, j, c;

  c = 1;
  j = 1;
  i = n - k + 1;

  for(; i <= n; ){
    c = c*i;
    c = c/j;

    i = i + 1;
    j = j + 1;
  }

  return c;
}
function mPermutations(n, k){
  var i, c;

  c = 1;

  for(i = n - k + 1; i <= n; i = i + 1){
    c = c*i;
  }

  return c;
}
function mEpsilonCompare(a, b, epsilon){
  return Math.abs(a - b) < epsilon;
}
function mGreatestCommonDivisor(a, b){
  var t;

  for(; b != 0; ){
    t = b;
    b = a%b;
    a = t;
  }

  return a;
}
function mGCDWithSubtraction(a, b){
  var g;

  if(a == 0){
    g = b;
  }else{
    for(; b != 0; ){
      if(a > b){
        a = a - b;
      }else{
        b = b - a;
      }
    }

    g = a;
  }

  return g;
}
function mIsInteger(a){
  return (a - Math.floor(a)) == 0;
}
function mGreatestCommonDivisorWithCheck(a, b, gcdReference){
  var success;
  var gcd;

  if(mIsInteger(a) && mIsInteger(b)){
    gcd = mGreatestCommonDivisor(a, b);
    gcdReference.numberValue = gcd;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function mLeastCommonMultiple(a, b){
  var lcm;

  if(a > 0 && b > 0){
    lcm = Math.abs(a*b)/mGreatestCommonDivisor(a, b);
  }else{
    lcm = 0;
  }

  return lcm;
}
function mSign(a){
  var s;

  if(a > 0){
    s = 1;
  }else if(a < 0){
    s =  -1;
  }else{
    s = 0;
  }

  return s;
}
function mMax(a, b){
  return Math.max(a, b);
}
function mMin(a, b){
  return Math.min(a, b);
}
function mPower(a, b){
  return Math.pow(a, b);
}
function mGamma(x){
  return mLanczosApproximation(x);
}
function mLogGamma(x){
  return Math.log(mGamma(x));
}
function mLanczosApproximation(z){
  var p;
  var i, y, t, x;

  p = [];
  p.length = 8;
  p[0] = 676.5203681218851;
  p[1] =  -1259.1392167224028;
  p[2] = 771.32342877765313;
  p[3] =  -176.61502916214059;
  p[4] = 12.507343278686905;
  p[5] =  -0.13857109526572012;
  p[6] = 9.9843695780195716e-6;
  p[7] = 1.5056327351493116e-7;

  if(z < 0.5){
    y = Math.PI/(Math.sin(Math.PI*z)*mLanczosApproximation(1 - z));
  }else{
    z = z - 1;
    x = 0.99999999999980993;
    for(i = 0; i < p.length; i = i + 1){
      x = x + p[i]/(z + i + 1);
    }
    t = z + p.length - 0.5;
    y = Math.sqrt(2*Math.PI)*Math.pow(t, z + 0.5)*Math.exp( -t)*x;
  }

  return y;
}
function mBeta(x, y){
  return mGamma(x)*mGamma(y)/mGamma(x + y);
}
function mSinh(x){
  return (Math.exp(x) - Math.exp( -x))/2;
}
function mCosh(x){
  return (Math.exp(x) + Math.exp( -x))/2;
}
function mTanh(x){
  return mSinh(x)/mCosh(x);
}
function mCot(x){
  return 1/Math.tan(x);
}
function mSec(x){
  return 1/Math.cos(x);
}
function mCsc(x){
  return 1/Math.sin(x);
}
function mCoth(x){
  return mCosh(x)/mSinh(x);
}
function mSech(x){
  return 1/mCosh(x);
}
function mCsch(x){
  return 1/mSinh(x);
}
function mError(x){
  var y, t, tau, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10;

  if(x == 0){
    y = 0;
  }else if(x < 0){
    y =  -mError( -x);
  }else{
    c1 =  -1.26551223;
    c2 =  +1.00002368;
    c3 =  +0.37409196;
    c4 =  +0.09678418;
    c5 =  -0.18628806;
    c6 =  +0.27886807;
    c7 =  -1.13520398;
    c8 =  +1.48851587;
    c9 =  -0.82215223;
    c10 =  +0.17087277;

    t = 1/(1 + 0.5*Math.abs(x));

    tau = t*Math.exp( -(Math.pow(x, 2)) + c1 + t*(c2 + t*(c3 + t*(c4 + t*(c5 + t*(c6 + t*(c7 + t*(c8 + t*(c9 + t*c10)))))))));

    y = 1 - tau;
  }

  return y;
}
function mErrorInverse(x){
  var y, a, t;

  a = (8*(Math.PI - 3))/(3*Math.PI*(4 - Math.PI));

  t = 2/(Math.PI*a) + Math.log(1 - Math.pow(x, 2))/2;
  y = mSign(x)*Math.sqrt(Math.sqrt(Math.pow(t, 2) - Math.log(1 - Math.pow(x, 2))/a) - t);

  return y;
}
function mFallingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x - k);
  }

  return y;
}
function mRisingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x + k);
  }

  return y;
}
function mHypergeometric(a, b, c, z, maxIterations, precision){
  var y;

  if(Math.abs(z) >= 0.5){
    y = Math.pow(1 - z,  -a)*mHypergeometricDirect(a, c - b, c, z/(z - 1), maxIterations, precision);
  }else{
    y = mHypergeometricDirect(a, b, c, z, maxIterations, precision);
  }

  return y;
}
function mHypergeometricDirect(a, b, c, z, maxIterations, precision){
  var y, yp, n;
  var done;

  y = 0;
  done = false;

  for(n = 0; n < maxIterations &&  !done ; n = n + 1){
    yp = mRisingFactorial(a, n)*mRisingFactorial(b, n)/mRisingFactorial(c, n)*Math.pow(z, n)/mFactorial(n);
    if(Math.abs(yp) < precision){
      done = true;
    }
    y = y + yp;
  }

  return y;
}
function mBernouilliNumber(n){
  return mAkiyamaTanigawaAlgorithm(n);
}
function mAkiyamaTanigawaAlgorithm(n){
  var m, j, B;
  var A;

  A = [];
  A.length = n + 1;

  for(m = 0; m <= n; m = m + 1){
    A[m] = 1/(m + 1);
    for(j = m; j >= 1; j = j - 1){
      A[j - 1] = j*(A[j - 1] - A[j]);
    }
  }

  B = A[0];

  delete(A);

  return B;
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function AddNumber(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddNumberRef(list, i){
  list.numberArray = AddNumber(list.numberArray, i);
}
function RemoveNumber(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetNumberRef(list, i){
  return list.numberArray[i];
}
function RemoveNumberRef(list, i){
  list.numberArray = RemoveNumber(list.numberArray, i);
}
function AddString(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;

  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddStringRef(list, i){
  list.stringArray = AddString(list.stringArray, i);
}
function RemoveString(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetStringRef(list, i){
  return list.stringArray[i];
}
function RemoveStringRef(list, i){
  list.stringArray = RemoveString(list.stringArray, i);
}
function CreateDynamicArrayCharacters(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayCharactersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddCharacter(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayCharactersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayCharactersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayCharactersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayCharactersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayCharactersIndex(da, index){
  return da.array[index];
}
function DynamicArrayCharactersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertCharacter(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayCharactersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArrayCharacterSet(da, index, value){
  var success;

  if(index < da.lengthx){
    da.array[index] = value;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DynamicArrayRemoveCharacter(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayCharactersDecreaseSizeNecessary(da)){
    DynamicArrayCharactersDecreaseSize(da);
  }
}
function FreeDynamicArrayCharacters(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayCharactersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayCharactersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.floor(n) + 1;

  da = CreateDynamicArrayCharactersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayCharacters(array){
  var da;

  da = {};
  da.array = CopyString(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayCharactersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayCharactersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListCharacter();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddCharacter(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayCharacters(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListCharactersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function AddBoolean(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddBooleanRef(list, i){
  list.booleanArray = AddBoolean(list.booleanArray, i);
}
function RemoveBoolean(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetBooleanRef(list, i){
  return list.booleanArray[i];
}
function RemoveDecimalRef(list, i){
  list.booleanArray = RemoveBoolean(list.booleanArray, i);
}
function CreateLinkedListString(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddString(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListStringsToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListStringsLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = {};
    array[i].string = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListStringsLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListString(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function CreateLinkedListNumbers(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function CreateLinkedListNumbersArray(lengthx){
  var lls;
  var i;

  lls = [];
  lls.length = lengthx;
  for(i = 0; i < lls.length; i = i + 1){
    lls[i] = CreateLinkedListNumbers();
  }

  return lls;
}
function LinkedListAddNumber(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListNumbersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function LinkedListNumbersIndex(ll, index){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  return node.value;
}
function LinkedListInsertNumber(ll, index, value){
  var i;
  var node, tmp;

  if(index == 0){
    tmp = ll.first;
    ll.first = {};
    ll.first.next = tmp;
    ll.first.value = value;
    ll.first.end = false;
  }else{
    node = ll.first;
    for(i = 0; i < index - 1; i = i + 1){
      node = node.next;
    }

    tmp = node.next;
    node.next = {};
    node.next.next = tmp;
    node.next.value = value;
    node.next.end = false;
  }
}
function LinkedListSet(ll, index, value){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  node.next.value = value;
}
function LinkedListRemoveNumber(ll, index){
  var i;
  var node, prev;

  node = ll.first;
  prev = ll.first;

  for(i = 0; i < index; i = i + 1){
    prev = node;
    node = node.next;
  }

  if(index == 0){
    ll.first = prev.next;
  }
  if( !prev.next.end ){
    prev.next = prev.next.next;
  }
}
function FreeLinkedListNumbers(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function FreeLinkedListNumbersArray(lls){
  var i;

  for(i = 0; i < lls.length; i = i + 1){
    FreeLinkedListNumbers(lls[i]);
  }
  delete(lls);
}
function LinkedListNumbersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListNumbersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function ArrayToLinkedListNumbers(array){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < array.length; i = i + 1){
    LinkedListAddNumber(ll, array[i]);
  }

  return ll;
}
function LinkedListNumbersEqual(a, b){
  var equal, done;
  var an, bn;

  an = a.first;
  bn = b.first;

  equal = true;
  done = false;
  for(; equal &&  !done ; ){
    if(an.end == bn.end){
      if(an.end){
        done = true;
      }else if(an.value == bn.value){
        an = an.next;
        bn = bn.next;
      }else{
        equal = false;
      }
    }else{
      equal = false;
    }
  }

  return equal;
}
function CreateLinkedListCharacter(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddCharacter(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListCharactersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListCharactersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListCharactersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListCharacter(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function LinkedListCharactersAddString(ll, str){
  var i;

  for(i = 0; i < str.length; i = i + 1){
    LinkedListAddCharacter(ll, str[i]);
  }
}
function CreateDynamicArrayNumbers(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayNumbersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddNumber(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumbersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayNumbersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersIndex(da, index){
  return da.array[index];
}
function DynamicArrayNumbersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertNumber(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumberSet(da, index, value){
  var success;

  if(index < da.lengthx){
    da.array[index] = value;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DynamicArrayRemoveNumber(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayNumbersDecreaseSizeNecessary(da)){
    DynamicArrayNumbersDecreaseSize(da);
  }
}
function FreeDynamicArrayNumbers(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayNumbersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayNumbersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  /*
         c = 10*(3/2)^n
         log(c) = log(10*(3/2)^n)
         log(c) = log(10) + log((3/2)^n)
         log(c) = 1 + log((3/2)^n)
         log(c) - 1 = log((3/2)^n)
         log(c) - 1 = n*log(3/2)
         n = (log(c) - 1)/log(3/2)
         */
  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.floor(n) + 1;

  da = CreateDynamicArrayNumbersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayNumbers(array){
  var da;

  da = {};
  da.array = CopyNumberArray(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayNumbersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayNumbersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddNumber(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayNumbers(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListNumbersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function DynamicArrayNumbersIndexOf(arr, n, foundReference){
  var found;
  var i;

  found = false;
  for(i = 0; i < arr.lengthx &&  !found ; i = i + 1){
    if(arr.array[i] == n){
      found = true;
    }
  }
  if( !found ){
    i =  -1;
  }else{
    i = i - 1;
  }

  foundReference.booleanValue = found;

  return i;
}
function DynamicArrayNumbersIsInArray(arr, n){
  var found;
  var i;

  found = false;
  for(i = 0; i < arr.lengthx &&  !found ; i = i + 1){
    if(arr.array[i] == n){
      found = true;
    }
  }

  return found;
}
function AddCharacter(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddCharacterRef(list, i){
  list.string = AddCharacter(list.string, i);
}
function RemoveCharacter(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }

  return newlist;
}
function GetCharacterRef(list, i){
  return list.string[i];
}
function RemoveCharacterRef(list, i){
  list.string = RemoveCharacter(list.string, i);
}
function nCreateStringScientificNotationDecimalFromNumber(decimal){
  var mantissaReference, exponentReference;
  var multiplier, inc;
  var exponent;
  var done, isPositive;
  var result;

  mantissaReference = {};
  exponentReference = {};
  result = [];
  result.length = 0;
  done = false;
  exponent = 0;

  if(decimal < 0){
    isPositive = false;
    decimal =  -decimal;
  }else{
    isPositive = true;
  }

  if(decimal == 0){
    done = true;
  }

  if( !done ){
    multiplier = 0;
    inc = 0;

    if(decimal < 1){
      multiplier = 10;
      inc =  -1;
    }else if(decimal >= 10){
      multiplier = 0.1;
      inc = 1;
    }else{
      done = true;
    }

    if( !done ){
      exponent = Math.round(Math.log10(decimal));
      exponent = Math.min(99, exponent);
      exponent = Math.max( -99, exponent);

      decimal = decimal/Math.pow(10, exponent);

      /* Adjust */
      for(; (decimal >= 10 || decimal < 1) && Math.abs(exponent) < 99; ){
        decimal = decimal*multiplier;
        exponent = exponent + inc;
      }
    }
  }

  nCreateStringFromNumberWithCheck(decimal, 10, mantissaReference);

  nCreateStringFromNumberWithCheck(exponent, 10, exponentReference);

  if( !isPositive ){
    result = AppendString(result, "-".split(''));
  }

  result = AppendString(result, mantissaReference.string);
  result = AppendString(result, "e".split(''));
  result = AppendString(result, exponentReference.string);

  return result;
}
function nCreateStringDecimalFromNumber(decimal){
  var stringReference;

  stringReference = {};

  /* This will succeed because base = 10. */
  nCreateStringFromNumberWithCheck(decimal, 10, stringReference);

  return stringReference.string;
}
function nCreateStringFromNumberWithCheck(decimal, base, stringReference){
  var string;
  var maximumDigits;
  var digitPosition;
  var hasPrintedPoint, isPositive;
  var i, d;
  var success;
  var characterReference;
  var c;

  string = CreateDynamicArrayCharacters();
  isPositive = true;

  if(decimal < 0){
    isPositive = false;
    decimal =  -decimal;
  }

  if(decimal == 0){
    DynamicArrayAddCharacter(string, '0');
    success = true;
  }else{
    characterReference = {};

    if(mIsInteger(base)){
      success = true;

      maximumDigits = nGetMaximumDigitsForBase(base);

      digitPosition = nGetFirstDigitPosition(decimal, base);

      decimal = Math.round(decimal*Math.pow(base, maximumDigits - digitPosition - 1));

      hasPrintedPoint = false;

      if( !isPositive ){
        DynamicArrayAddCharacter(string, '-');
      }

      /* Print leading zeros. */
      if(digitPosition < 0){
        DynamicArrayAddCharacter(string, '0');
        DynamicArrayAddCharacter(string, '.');
        hasPrintedPoint = true;
        for(i = 0; i <  -digitPosition - 1; i = i + 1){
          DynamicArrayAddCharacter(string, '0');
        }
      }

      /* Print number. */
      for(i = 0; i < maximumDigits && success; i = i + 1){
        d = Math.floor(decimal/Math.pow(base, maximumDigits - i - 1));

        if(d >= base){
          d = base - 1;
        }

        if( !hasPrintedPoint  && digitPosition - i + 1 == 0){
          if(decimal != 0){
            DynamicArrayAddCharacter(string, '.');
          }
          hasPrintedPoint = true;
        }

        if(decimal == 0 && hasPrintedPoint){
        }else{
          success = nGetSingleDigitCharacterFromNumberWithCheck(d, base, characterReference);
          if(success){
            c = characterReference.characterValue;
            DynamicArrayAddCharacter(string, c);
          }
        }

        if(success){
          decimal = decimal - d*Math.pow(base, maximumDigits - i - 1);
        }
      }

      if(success){
        /* Print trailing zeros. */
        for(i = 0; i < digitPosition - maximumDigits + 1; i = i + 1){
          DynamicArrayAddCharacter(string, '0');
        }
      }
    }else{
      success = false;
    }
  }

  if(success){
    stringReference.string = DynamicArrayCharactersToArray(string);
    FreeDynamicArrayCharacters(string);
  }

  /* Done */
  return success;
}
function nGetMaximumDigitsForBase(base){
  var t;

  t = Math.pow(10, 15);
  return Math.floor(Math.log10(t)/Math.log10(base));
}
function nGetFirstDigitPosition(decimal, base){
  var power;
  var t;

  power = Math.ceil(Math.log10(decimal)/Math.log10(base));

  t = decimal*Math.pow(base,  -power);
  if(t < base && t >= 1){
  }else if(t >= base){
    power = power + 1;
  }else if(t < 1){
    power = power - 1;
  }

  return power;
}
function nGetSingleDigitCharacterFromNumberWithCheck(c, base, characterReference){
  var numberTable;
  var success;

  numberTable = nGetDigitCharacterTable();

  if(c < base || c < numberTable.length){
    success = true;
    characterReference.characterValue = numberTable[c];
  }else{
    success = false;
  }

  return success;
}
function nGetDigitCharacterTable(){
  var numberTable;

  numberTable = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ".split('');

  return numberTable;
}
function nCreateNumberFromDecimalStringWithCheck(string, decimalReference, errorMessage){
  return nCreateNumberFromStringWithCheck(string, 10, decimalReference, errorMessage);
}
function nCreateNumberFromDecimalString(string){
  var doubleReference;
  var stringReference;
  var number;

  doubleReference = CreateNumberReference(0);
  stringReference = CreateStringReference("".split(''));
  nCreateNumberFromStringWithCheck(string, 10, doubleReference, stringReference);
  number = doubleReference.numberValue;

  delete(doubleReference);
  delete(stringReference);

  return number;
}
function nCreateNumberFromStringWithCheck(string, base, numberReference, errorMessage){
  var success;
  var numberIsPositive, exponentIsPositive;
  var beforePoint, afterPoint, exponent;

  numberIsPositive = CreateBooleanReference(true);
  exponentIsPositive = CreateBooleanReference(true);
  beforePoint = {};
  afterPoint = {};
  exponent = {};

  if(base >= 2 && base <= 36){
    success = nExtractPartsFromNumberString(string, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessage);

    if(success){
      numberReference.numberValue = nCreateNumberFromParts(base, numberIsPositive.booleanValue, beforePoint.numberArray, afterPoint.numberArray, exponentIsPositive.booleanValue, exponent.numberArray);
    }
  }else{
    success = false;
    errorMessage.string = "Base must be from 2 to 36.".split('');
  }

  return success;
}
function nCreateNumberFromParts(base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent){
  var n, i, p, e;

  n = 0;

  for(i = 0; i < beforePoint.length; i = i + 1){
    p = beforePoint[beforePoint.length - i - 1];

    n = n + p*Math.pow(base, i);
  }

  for(i = 0; i < afterPoint.length; i = i + 1){
    p = afterPoint[i];

    n = n + p*Math.pow(base,  -(i + 1));
  }

  if(exponent.length > 0){
    e = 0;
    for(i = 0; i < exponent.length; i = i + 1){
      p = exponent[exponent.length - i - 1];

      e = e + p*Math.pow(base, i);
    }

    if( !exponentIsPositive ){
      e =  -e;
    }

    n = n*Math.pow(base, e);
  }

  if( !numberIsPositive ){
    n =  -n;
  }

  return n;
}
function nExtractPartsFromNumberString(n, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages){
  var i, j, count;
  var success, done, complete;

  i = 0;
  complete = false;

  if(i < n.length){
    if(n[i] == '-'){
      numberIsPositive.booleanValue = false;
      i = i + 1;
    }else if(n[i] == '+'){
      numberIsPositive.booleanValue = true;
      i = i + 1;
    }

    success = true;
  }else{
    success = false;
    errorMessages.string = "Number cannot have length zero.".split('');
  }

  if(success){
    done = false;
    count = 0;
    for(; i + count < n.length &&  !done ; ){
      if(nCharacterIsNumberCharacterInBase(n[i + count], base)){
        count = count + 1;
      }else{
        done = true;
      }
    }

    if(count >= 1){
      beforePoint.numberArray = [];
      beforePoint.numberArray.length = count;

      for(j = 0; j < count; j = j + 1){
        beforePoint.numberArray[j] = nGetNumberFromNumberCharacterForBase(n[i + j], base);
      }

      i = i + count;

      if(i < n.length){
        success = true;
      }else{
        afterPoint.numberArray = [];
        afterPoint.numberArray.length = 0;
        exponent.numberArray = [];
        exponent.numberArray.length = 0;
        success = true;
        complete = true;
      }
    }else{
      success = false;
      errorMessages.string = "Number must have at least one number after the optional sign.".split('');
    }
  }

  if(success &&  !complete ){
    if(n[i] == '.'){
      i = i + 1;

      if(i < n.length){
        done = false;
        count = 0;
        for(; i + count < n.length &&  !done ; ){
          if(nCharacterIsNumberCharacterInBase(n[i + count], base)){
            count = count + 1;
          }else{
            done = true;
          }
        }

        if(count >= 1){
          afterPoint.numberArray = [];
          afterPoint.numberArray.length = count;

          for(j = 0; j < count; j = j + 1){
            afterPoint.numberArray[j] = nGetNumberFromNumberCharacterForBase(n[i + j], base);
          }

          i = i + count;

          if(i < n.length){
            success = true;
          }else{
            exponent.numberArray = [];
            exponent.numberArray.length = 0;
            success = true;
            complete = true;
          }
        }else{
          success = false;
          errorMessages.string = "There must be at least one digit after the decimal point.".split('');
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the decimal point.".split('');
      }
    }else if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
      if(i < n.length){
        success = true;
        afterPoint.numberArray = [];
        afterPoint.numberArray.length = 0;
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the exponent.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "Expected decimal point or exponent symbol.".split('');
    }
  }

  if(success &&  !complete ){
    if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
      i = i + 1;

      if(i < n.length){
        if(n[i] == '-'){
          exponentIsPositive.booleanValue = false;
          i = i + 1;
        }else if(n[i] == '+'){
          exponentIsPositive.booleanValue = true;
          i = i + 1;
        }

        if(i < n.length){
          done = false;
          count = 0;
          for(; i + count < n.length &&  !done ; ){
            if(nCharacterIsNumberCharacterInBase(n[i + count], base)){
              count = count + 1;
            }else{
              done = true;
            }
          }

          if(count >= 1){
            exponent.numberArray = [];
            exponent.numberArray.length = count;

            for(j = 0; j < count; j = j + 1){
              exponent.numberArray[j] = nGetNumberFromNumberCharacterForBase(n[i + j], base);
            }

            i = i + count;

            if(i == n.length){
              success = true;
            }else{
              success = false;
              errorMessages.string = "There cannot be any characters past the exponent of the number.".split('');
            }
          }else{
            success = false;
            errorMessages.string = "There must be at least one digit after the decimal point.".split('');
          }
        }else{
          success = false;
          errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "Expected exponent symbol.".split('');
    }
  }

  return success;
}
function nGetNumberFromNumberCharacterForBase(c, base){
  var numberTable;
  var i;
  var position;

  numberTable = nGetDigitCharacterTable();
  position = 0;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      position = i;
    }
  }

  return position;
}
function nCharacterIsNumberCharacterInBase(c, base){
  var numberTable;
  var i;
  var found;

  numberTable = nGetDigitCharacterTable();
  found = false;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      found = true;
    }
  }

  return found;
}
function nStringToNumberArray(str){
  var numberArrayReference;
  var stringReference;
  var numbers;

  numberArrayReference = {};
  stringReference = {};

  nStringToNumberArrayWithCheck(str, numberArrayReference, stringReference);

  numbers = numberArrayReference.numberArray;

  delete(numberArrayReference);
  delete(stringReference);

  return numbers;
}
function nStringToNumberArrayWithCheck(str, numberArrayReference, errorMessage){
  var numberStrings;
  var numbers;
  var i;
  var numberString, trimmedNumberString;
  var success;
  var numberReference;

  numberStrings = SplitByString(str, ",".split(''));

  numbers = [];
  numbers.length = numberStrings.length;
  success = true;
  numberReference = {};

  for(i = 0; i < numberStrings.length; i = i + 1){
    numberString = numberStrings[i].string;
    trimmedNumberString = Trim(numberString);
    success = nCreateNumberFromDecimalStringWithCheck(trimmedNumberString, numberReference, errorMessage);
    numbers[i] = numberReference.numberValue;

    FreeStringReference(numberStrings[i]);
    delete(trimmedNumberString);
  }

  delete(numberStrings);
  delete(numberReference);

  numberArrayReference.numberArray = numbers;

  return success;
}
function cCreateComplexNumber(re, im){
  var z;

  z = {};
  z.re = re;
  z.im = im;

  return z;
}
function cCreatePolarComplexNumber(r, phi){
  var p;

  p = {};
  p.r = r;
  p.phi = phi;

  return p;
}
function cAdd(z1, z2){
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  z1.re = a + c;
  z1.im = b + d;
}
function cAddToNew(z1, z2){
  var x;
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  x = {};

  x.re = a + c;
  x.im = b + d;

  return x;
}
function cSub(z1, z2){
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  z1.re = a - c;
  z1.im = b - d;
}
function cSubToNew(z1, z2){
  var x;
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  x = {};

  x.re = a - c;
  x.im = b - d;

  return x;
}
function cMul(z1, z2){
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  z1.re = a*c - b*d;
  z1.im = b*c + a*d;
}
function cMulToNew(z1, z2){
  var x;
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  x = {};

  x.re = a*c - b*d;
  x.im = b*c + a*d;

  return x;
}
function cDiv(z1, z2){
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  z1.re = (a*c + b*d)/(Math.pow(c, 2) + Math.pow(d, 2));
  z1.im = (b*c - a*d)/(Math.pow(c, 2) + Math.pow(d, 2));
}
function cDivToNew(z1, z2){
  var x;
  var a, b, c, d;

  a = z1.re;
  b = z1.im;
  c = z2.re;
  d = z2.im;

  x = {};

  x.re = (a*c + b*d)/(Math.pow(c, 2) + Math.pow(d, 2));
  x.im = (b*c - a*d)/(Math.pow(c, 2) + Math.pow(d, 2));

  return x;
}
function cConjugate(z){
  z.im =  -z.im;
}
function cConjugateToNew(z){
  var x;

  x = {};

  x.re = z.re;
  x.im =  -z.im;

  return x;
}
function cAbs(z){
  var x;

  x = Math.sqrt(Math.pow(z.re, 2) + Math.pow(z.im, 2));

  return x;
}
function cArg(z){
  var x;

  x = mAtan2(z.im, z.re);

  return x;
}
function cCreatePolarFromComplexNumber(z){
  var x;

  x = {};

  x.r = cAbs(z);
  x.phi = cArg(z);

  return x;
}
function cCreateComplexFromPolar(p){
  var z;

  z = {};

  z.re = p.r*Math.cos(p.phi);
  z.im = p.r*Math.sin(p.phi);

  return z;
}
function cRe(z){
  return z.re;
}
function cIm(z){
  return z.im;
}
function cAddPolar(p1, p2){
  var x;
  var z1, z2;

  z1 = cCreateComplexFromPolar(p1);
  z2 = cCreateComplexFromPolar(p2);

  cAdd(z1, z2);

  x = cCreatePolarFromComplexNumber(z1);

  p1.r = x.r;
  p1.phi = x.phi;

  delete(z1);
  delete(z2);
  delete(x);
}
function cAddPolarToNew(p1, p2){
  var x;
  var z1, z2;

  z1 = cCreateComplexFromPolar(p1);
  z2 = cCreateComplexFromPolar(p2);

  cAdd(z1, z2);

  x = cCreatePolarFromComplexNumber(z1);

  delete(z1);
  delete(z2);

  return x;
}
function cSubPolar(p1, p2){
  var x;
  var z1, z2;

  z1 = cCreateComplexFromPolar(p1);
  z2 = cCreateComplexFromPolar(p2);

  cSub(z1, z2);

  x = cCreatePolarFromComplexNumber(z1);

  p1.r = x.r;
  p1.phi = x.phi;

  delete(z1);
  delete(z2);
  delete(x);
}
function cSubPolarToNew(p1, p2){
  var x;
  var z1, z2;

  z1 = cCreateComplexFromPolar(p1);
  z2 = cCreateComplexFromPolar(p2);

  cSub(z1, z2);

  x = cCreatePolarFromComplexNumber(z1);

  delete(z1);
  delete(z2);

  return x;
}
function cMulPolar(p1, p2){
  var r1, r2, phi1, phi2;

  r1 = p1.r;
  r2 = p2.r;
  phi1 = p1.phi;
  phi2 = p2.phi;

  p1.r = r1*r2;
  p1.phi = phi1 + phi2;
}
function cMulPolarToNew(p1, p2){
  var x;
  var r1, r2, phi1, phi2;

  r1 = p1.r;
  r2 = p2.r;
  phi1 = p1.phi;
  phi2 = p2.phi;

  x = {};

  x.r = r1*r2;
  x.phi = phi1 + phi2;

  return x;
}
function cDivPolar(p1, p2){
  var r1, r2, phi1, phi2;

  r1 = p1.r;
  r2 = p2.r;
  phi1 = p1.phi;
  phi2 = p2.phi;

  p1.r = r1/r2;
  p1.phi = phi1 - phi2;
}
function cDivPolarToNew(p1, p2){
  var x;
  var r1, r2, phi1, phi2;

  r1 = p1.r;
  r2 = p2.r;
  phi1 = p1.phi;
  phi2 = p2.phi;

  x = {};

  x.r = r1/r2;
  x.phi = phi1 - phi2;

  return x;
}
function cSquareRoot(z){
  var a, b, m;

  a = z.re;
  b = z.im;

  m = Math.sqrt(Math.pow(a, 2) + Math.pow(b, 2));

  z.re = Math.sqrt((m + a)/2);
  z.im = mSign(b)*Math.sqrt((m - a)/2);
}
function cPowerPolar(p, n){
  p.r = Math.pow(p.r, n);
  p.phi = p.phi*n;
}
function cPowerToNew(z, n){
  var p;
  var zp;

  p = cCreatePolarFromComplexNumber(z);
  cPowerPolar(p, n);
  zp = cCreateComplexFromPolar(p);

  delete(p);

  return zp;
}
function cPower(z, n){
  var zp;

  zp = cPowerToNew(z, n);
  z.re = zp.re;
  z.im = zp.im;

  delete(zp);
}
function cNegate(z){
  z.re = mNegate(z.re);
  z.im = mNegate(z.im);
}
function cAssignComplexByValues(s, re, im){
  s.re = re;
  s.im = im;
}
function cAssignComplex(a, b){
  a.re = b.re;
  a.im = b.im;
}
function cEpsilonCompareComplex(a, b, epsilon){
  return mEpsilonCompare(a.re, b.re, epsilon) && mEpsilonCompare(a.im, b.im, epsilon);
}
function cExpComplex(x){
  var re, im;

  re = Math.exp(x.re)*Math.cos(x.im);
  im = Math.exp(x.re)*Math.sin(x.im);
  x.re = re;
  x.im = im;
}
function cSineComplex(x){
  var re, im;

  re = Math.sin(x.re)*mCosh(x.im);
  im = Math.cos(x.re)*mSinh(x.im);
  x.re = re;
  x.im = im;
}
function cCosineComplex(x){
  var re, im;

  re = Math.cos(x.re)*mCosh(x.im);
  im = Math.sin(x.re)*mSinh(x.im);
  x.re = re;
  x.im = im;
}
function cComplexToString(a){
  var str, number;
  var ll;
  var i;

  ll = CreateLinkedListCharacter();

  number = nCreateStringDecimalFromNumber(a.re);

  for(i = 0; i < number.length; i = i + 1){
    LinkedListAddCharacter(ll, number[i]);
  }

  delete(number);

  if(a.im < 0){
    LinkedListAddCharacter(ll, '-');
    number = nCreateStringDecimalFromNumber( -a.im);
  }else{
    LinkedListAddCharacter(ll, '+');
    number = nCreateStringDecimalFromNumber(a.im);
  }

  for(i = 0; i < number.length; i = i + 1){
    LinkedListAddCharacter(ll, number[i]);
  }

  delete(number);

  LinkedListAddCharacter(ll, 'i');

  str = LinkedListCharactersToArray(ll);
  FreeLinkedListCharacter(ll);

  return str;
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function SwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function ReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    SwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}
function WriteStringToStingStream(stream, index, src){
  var i;

  for(i = 0; i < src.length; i = i + 1){
    stream[index.numberValue + i] = src[i];
  }
  index.numberValue = index.numberValue + src.length;
}
function WriteCharacterToStingStream(stream, index, src){
  stream[index.numberValue] = src;
  index.numberValue = index.numberValue + 1;
}
function WriteBooleanToStingStream(stream, index, src){
  if(src){
    WriteStringToStingStream(stream, index, "true".split(''));
  }else{
    WriteStringToStingStream(stream, index, "false".split(''));
  }
}
function SubstringWithCheck(string, from, to, stringReference){
  var success;

  if(from >= 0 && from <= string.length && to >= 0 && to <= string.length && from <= to){
    stringReference.string = Substring(string, from, to);
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Substring(string, from, to){
  var n;
  var i, lengthx;

  lengthx = to - from;

  n = [];
  n.length = lengthx;

  for(i = from; i < to; i = i + 1){
    n[i - from] = string[i];
  }

  return n;
}
function AppendString(s1, s2){
  var newString;

  newString = ConcatenateString(s1, s2);

  delete(s1);

  return newString;
}
function ConcatenateString(s1, s2){
  var newString;
  var i;

  newString = [];
  newString.length = s1.length + s2.length;

  for(i = 0; i < s1.length; i = i + 1){
    newString[i] = s1[i];
  }

  for(i = 0; i < s2.length; i = i + 1){
    newString[s1.length + i] = s2[i];
  }

  return newString;
}
function AppendCharacter(string, c){
  var newString;

  newString = ConcatenateCharacter(string, c);

  delete(string);

  return newString;
}
function ConcatenateCharacter(string, c){
  var newString;
  var i;
  newString = [];
  newString.length = string.length + 1;

  for(i = 0; i < string.length; i = i + 1){
    newString[i] = string[i];
  }

  newString[string.length] = c;

  return newString;
}
function SplitByCharacter(toSplit, splitBy){
  var split;
  var stringToSplitBy;

  stringToSplitBy = [];
  stringToSplitBy.length = 1;
  stringToSplitBy[0] = splitBy;

  split = SplitByString(toSplit, stringToSplitBy);

  delete(stringToSplitBy);

  return split;
}
function IndexOfCharacter(string, character, indexReference){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function SubstringEqualsWithCheck(string, from, substring, equalsReference){
  var success;

  if(from < string.length){
    success = true;
    equalsReference.booleanValue = SubstringEquals(string, from, substring);
  }else{
    success = false;
  }

  return success;
}
function SubstringEquals(string, from, substring){
  var i;
  var equal;

  equal = true;
  if(string.length - from >= substring.length){
    for(i = 0; i < substring.length && equal; i = i + 1){
      if(string[from + i] != substring[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function IndexOfString(string, substring, indexReference){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length - substring.length + 1 &&  !found ; i = i + 1){
    if(SubstringEquals(string, i, substring)){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function ContainsCharacter(string, character){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
    }
  }

  return found;
}
function ContainsString(string, substring){
  return IndexOfString(string, substring, {});
}
function ToUpperCase(string){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToUpperCase(string[i]);
  }
}
function ToLowerCase(string){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToLowerCase(string[i]);
  }
}
function EqualsIgnoreCase(a, b){
  var equal;
  var i;

  if(a.length == b.length){
    equal = true;
    for(i = 0; i < a.length && equal; i = i + 1){
      if(charToLowerCase(a[i]) != charToLowerCase(b[i])){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function ReplaceString(string, toReplace, replaceWith){
  var result;
  var i, j;
  var equalsReference;
  var success;
  var da;

  da = CreateDynamicArrayCharacters();

  equalsReference = {};

  for(i = 0; i < string.length; ){
    success = SubstringEqualsWithCheck(string, i, toReplace, equalsReference);
    if(success){
      success = equalsReference.booleanValue;
    }

    if(success && toReplace.length > 0){
      for(j = 0; j < replaceWith.length; j = j + 1){
        DynamicArrayAddCharacter(da, replaceWith[j]);
      }
      i = i + toReplace.length;
    }else{
      DynamicArrayAddCharacter(da, string[i]);
      i = i + 1;
    }
  }

  result = DynamicArrayCharactersToArray(da);

  FreeDynamicArrayCharacters(da);

  return result;
}
function ReplaceCharacterToNew(string, toReplace, replaceWith){
  var result;
  var i;

  result = [];
  result.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    if(string[i] == toReplace){
      result[i] = replaceWith;
    }else{
      result[i] = string[i];
    }
  }

  return result;
}
function ReplaceCharacter(string, toReplace, replaceWith){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    if(string[i] == toReplace){
      string[i] = replaceWith;
    }
  }
}
function Trim(string){
  var result;
  var i, lastWhitespaceLocationStart, lastWhitespaceLocationEnd;
  var firstNonWhitespaceFound;

  /* Find whitepaces at the start. */
  lastWhitespaceLocationStart =  -1;
  firstNonWhitespaceFound = false;
  for(i = 0; i < string.length &&  !firstNonWhitespaceFound ; i = i + 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationStart = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  /* Find whitepaces at the end. */
  lastWhitespaceLocationEnd = string.length;
  firstNonWhitespaceFound = false;
  for(i = string.length - 1; i >= 0 &&  !firstNonWhitespaceFound ; i = i - 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationEnd = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  if(lastWhitespaceLocationStart < lastWhitespaceLocationEnd){
    result = Substring(string, lastWhitespaceLocationStart + 1, lastWhitespaceLocationEnd);
  }else{
    result = [];
    result.length = 0;
  }

  return result;
}
function StartsWith(string, start){
  var startsWithString;

  startsWithString = false;
  if(string.length >= start.length){
    startsWithString = SubstringEquals(string, 0, start);
  }

  return startsWithString;
}
function EndsWith(string, end){
  var endsWithString;

  endsWithString = false;
  if(string.length >= end.length){
    endsWithString = SubstringEquals(string, string.length - end.length, end);
  }

  return endsWithString;
}
function SplitByString(toSplit, splitBy){
  var split;
  var next;
  var i;
  var c;
  var n;

  split = [];
  split.length = 0;

  next = [];
  next.length = 0;
  for(i = 0; i < toSplit.length; ){
    c = toSplit[i];

    if(SubstringEquals(toSplit, i, splitBy)){
      n = {};
      n.string = next;
      split = AddString(split, n);
      next = [];
      next.length = 0;
      i = i + splitBy.length;
    }else{
      next = AppendCharacter(next, c);
      i = i + 1;
    }
  }

  n = {};
  n.string = next;
  split = AddString(split, n);

  return split;
}
function StringIsBefore(a, b){
  var before, equal, done;
  var i;

  before = false;
  equal = true;
  done = false;

  if(a.length == 0 && b.length > 0){
    before = true;
  }else{
    for(i = 0; i < a.length && i < b.length &&  !done ; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
      if(charCharacterIsBefore(a[i], b[i])){
        before = true;
      }
      if(charCharacterIsBefore(b[i], a[i])){
        done = true;
      }
    }

    if(equal){
      if(a.length < b.length){
        before = true;
      }
    }
  }

  return before;
}
function charToLowerCase(character){
  var toReturn;

  toReturn = character;
  if(character == 'A'){
    toReturn = 'a';
  }else if(character == 'B'){
    toReturn = 'b';
  }else if(character == 'C'){
    toReturn = 'c';
  }else if(character == 'D'){
    toReturn = 'd';
  }else if(character == 'E'){
    toReturn = 'e';
  }else if(character == 'F'){
    toReturn = 'f';
  }else if(character == 'G'){
    toReturn = 'g';
  }else if(character == 'H'){
    toReturn = 'h';
  }else if(character == 'I'){
    toReturn = 'i';
  }else if(character == 'J'){
    toReturn = 'j';
  }else if(character == 'K'){
    toReturn = 'k';
  }else if(character == 'L'){
    toReturn = 'l';
  }else if(character == 'M'){
    toReturn = 'm';
  }else if(character == 'N'){
    toReturn = 'n';
  }else if(character == 'O'){
    toReturn = 'o';
  }else if(character == 'P'){
    toReturn = 'p';
  }else if(character == 'Q'){
    toReturn = 'q';
  }else if(character == 'R'){
    toReturn = 'r';
  }else if(character == 'S'){
    toReturn = 's';
  }else if(character == 'T'){
    toReturn = 't';
  }else if(character == 'U'){
    toReturn = 'u';
  }else if(character == 'V'){
    toReturn = 'v';
  }else if(character == 'W'){
    toReturn = 'w';
  }else if(character == 'X'){
    toReturn = 'x';
  }else if(character == 'Y'){
    toReturn = 'y';
  }else if(character == 'Z'){
    toReturn = 'z';
  }

  return toReturn;
}
function charToUpperCase(character){
  var toReturn;

  toReturn = character;
  if(character == 'a'){
    toReturn = 'A';
  }else if(character == 'b'){
    toReturn = 'B';
  }else if(character == 'c'){
    toReturn = 'C';
  }else if(character == 'd'){
    toReturn = 'D';
  }else if(character == 'e'){
    toReturn = 'E';
  }else if(character == 'f'){
    toReturn = 'F';
  }else if(character == 'g'){
    toReturn = 'G';
  }else if(character == 'h'){
    toReturn = 'H';
  }else if(character == 'i'){
    toReturn = 'I';
  }else if(character == 'j'){
    toReturn = 'J';
  }else if(character == 'k'){
    toReturn = 'K';
  }else if(character == 'l'){
    toReturn = 'L';
  }else if(character == 'm'){
    toReturn = 'M';
  }else if(character == 'n'){
    toReturn = 'N';
  }else if(character == 'o'){
    toReturn = 'O';
  }else if(character == 'p'){
    toReturn = 'P';
  }else if(character == 'q'){
    toReturn = 'Q';
  }else if(character == 'r'){
    toReturn = 'R';
  }else if(character == 's'){
    toReturn = 'S';
  }else if(character == 't'){
    toReturn = 'T';
  }else if(character == 'u'){
    toReturn = 'U';
  }else if(character == 'v'){
    toReturn = 'V';
  }else if(character == 'w'){
    toReturn = 'W';
  }else if(character == 'x'){
    toReturn = 'X';
  }else if(character == 'y'){
    toReturn = 'Y';
  }else if(character == 'z'){
    toReturn = 'Z';
  }

  return toReturn;
}
function charIsUpperCase(character){
  var isUpper;

  isUpper = true;
  if(character == 'A'){
  }else if(character == 'B'){
  }else if(character == 'C'){
  }else if(character == 'D'){
  }else if(character == 'E'){
  }else if(character == 'F'){
  }else if(character == 'G'){
  }else if(character == 'H'){
  }else if(character == 'I'){
  }else if(character == 'J'){
  }else if(character == 'K'){
  }else if(character == 'L'){
  }else if(character == 'M'){
  }else if(character == 'N'){
  }else if(character == 'O'){
  }else if(character == 'P'){
  }else if(character == 'Q'){
  }else if(character == 'R'){
  }else if(character == 'S'){
  }else if(character == 'T'){
  }else if(character == 'U'){
  }else if(character == 'V'){
  }else if(character == 'W'){
  }else if(character == 'X'){
  }else if(character == 'Y'){
  }else if(character == 'Z'){
  }else{
    isUpper = false;
  }

  return isUpper;
}
function charIsLowerCase(character){
  var isLower;

  isLower = true;
  if(character == 'a'){
  }else if(character == 'b'){
  }else if(character == 'c'){
  }else if(character == 'd'){
  }else if(character == 'e'){
  }else if(character == 'f'){
  }else if(character == 'g'){
  }else if(character == 'h'){
  }else if(character == 'i'){
  }else if(character == 'j'){
  }else if(character == 'k'){
  }else if(character == 'l'){
  }else if(character == 'm'){
  }else if(character == 'n'){
  }else if(character == 'o'){
  }else if(character == 'p'){
  }else if(character == 'q'){
  }else if(character == 'r'){
  }else if(character == 's'){
  }else if(character == 't'){
  }else if(character == 'u'){
  }else if(character == 'v'){
  }else if(character == 'w'){
  }else if(character == 'x'){
  }else if(character == 'y'){
  }else if(character == 'z'){
  }else{
    isLower = false;
  }

  return isLower;
}
function charIsLetter(character){
  return charIsUpperCase(character) || charIsLowerCase(character);
}
function charIsNumber(character){
  var isNumberx;

  isNumberx = true;
  if(character == '0'){
  }else if(character == '1'){
  }else if(character == '2'){
  }else if(character == '3'){
  }else if(character == '4'){
  }else if(character == '5'){
  }else if(character == '6'){
  }else if(character == '7'){
  }else if(character == '8'){
  }else if(character == '9'){
  }else{
    isNumberx = false;
  }

  return isNumberx;
}
function charIsWhiteSpace(character){
  var isWhiteSpacex;

  isWhiteSpacex = true;
  if(character == ' '){
  }else if(character == '\t'){
  }else if(character == '\n'){
  }else if(character == '\r'){
  }else{
    isWhiteSpacex = false;
  }

  return isWhiteSpacex;
}
function charIsSymbol(character){
  var isSymbolx;

  isSymbolx = true;
  if(character == '!'){
  }else if(character == '\"'){
  }else if(character == '#'){
  }else if(character == '$'){
  }else if(character == '%'){
  }else if(character == '&'){
  }else if(character == '\''){
  }else if(character == '('){
  }else if(character == ')'){
  }else if(character == '*'){
  }else if(character == '+'){
  }else if(character == ','){
  }else if(character == '-'){
  }else if(character == '.'){
  }else if(character == '/'){
  }else if(character == ':'){
  }else if(character == ';'){
  }else if(character == '<'){
  }else if(character == '='){
  }else if(character == '>'){
  }else if(character == '?'){
  }else if(character == '@'){
  }else if(character == '['){
  }else if(character == '\\'){
  }else if(character == ']'){
  }else if(character == '^'){
  }else if(character == '_'){
  }else if(character == '`'){
  }else if(character == '{'){
  }else if(character == '|'){
  }else if(character == '}'){
  }else if(character == '~'){
  }else{
    isSymbolx = false;
  }

  return isSymbolx;
}
function charCharacterIsBefore(a, b){
  var ad, bd;

  ad = a.charCodeAt(0);
  bd = b.charCodeAt(0);

  return ad < bd;
}
function charDecimalDigitToCharacter(digit){
  var c;
  if(digit == 1){
    c = '1';
  }else if(digit == 2){
    c = '2';
  }else if(digit == 3){
    c = '3';
  }else if(digit == 4){
    c = '4';
  }else if(digit == 5){
    c = '5';
  }else if(digit == 6){
    c = '6';
  }else if(digit == 7){
    c = '7';
  }else if(digit == 8){
    c = '8';
  }else if(digit == 9){
    c = '9';
  }else{
    c = '0';
  }
  return c;
}
function charCharacterToDecimalDigit(c){
  var digit;

  if(c == '1'){
    digit = 1;
  }else if(c == '2'){
    digit = 2;
  }else if(c == '3'){
    digit = 3;
  }else if(c == '4'){
    digit = 4;
  }else if(c == '5'){
    digit = 5;
  }else if(c == '6'){
    digit = 6;
  }else if(c == '7'){
    digit = 7;
  }else if(c == '8'){
    digit = 8;
  }else if(c == '9'){
    digit = 9;
  }else{
    digit = 0;
  }

  return digit;
}


module.exports = {
	PolynomialToTextDirect: PolynomialToTextDirect,
	GenerateCommonRenderSpecification: GenerateCommonRenderSpecification,
	PolynomialToText: PolynomialToText,
	ComplexPolynomialToTextDirect: ComplexPolynomialToTextDirect,
	Add: Add,
	Subtract: Subtract,
	Multiply: Multiply,
	Divide: Divide,
	IsZero: IsZero,
	Assign: Assign,
	CreatePolynomial: CreatePolynomial,
	Fill: Fill,
	Degree: Degree,
	Lead: Lead,
	Evaluate: Evaluate,
	EvaluateWithHornersMethod: EvaluateWithHornersMethod,
	EvaluateWithPowers: EvaluateWithPowers,
	EvaluateDerivative: EvaluateDerivative,
	Derivative: Derivative,
	AddComplex: AddComplex,
	SubtractComplex: SubtractComplex,
	IsZeroComplex: IsZeroComplex,
	AssignComplex: AssignComplex,
	CreateComplexPolynomial: CreateComplexPolynomial,
	FillComplex: FillComplex,
	DegreeComplex: DegreeComplex,
	LeadComplex: LeadComplex,
	EvaluateComplex: EvaluateComplex,
	TotalNumberOfRoots: TotalNumberOfRoots,
	mNegate: mNegate,
	mPositive: mPositive,
	mFactorial: mFactorial,
	mRound: mRound,
	mBankersRound: mBankersRound,
	mCeil: mCeil,
	mFloor: mFloor,
	mTruncate: mTruncate,
	mAbsolute: mAbsolute,
	mLogarithm: mLogarithm,
	mNaturalLogarithm: mNaturalLogarithm,
	mSin: mSin,
	mCos: mCos,
	mTan: mTan,
	mAsin: mAsin,
	mAcos: mAcos,
	mAtan: mAtan,
	mAtan2: mAtan2,
	mSquareroot: mSquareroot,
	mExp: mExp,
	mDivisibleBy: mDivisibleBy,
	mCombinations: mCombinations,
	mPermutations: mPermutations,
	mEpsilonCompare: mEpsilonCompare,
	mGreatestCommonDivisor: mGreatestCommonDivisor,
	mGCDWithSubtraction: mGCDWithSubtraction,
	mIsInteger: mIsInteger,
	mGreatestCommonDivisorWithCheck: mGreatestCommonDivisorWithCheck,
	mLeastCommonMultiple: mLeastCommonMultiple,
	mSign: mSign,
	mMax: mMax,
	mMin: mMin,
	mPower: mPower,
	mGamma: mGamma,
	mLogGamma: mLogGamma,
	mLanczosApproximation: mLanczosApproximation,
	mBeta: mBeta,
	mSinh: mSinh,
	mCosh: mCosh,
	mTanh: mTanh,
	mCot: mCot,
	mSec: mSec,
	mCsc: mCsc,
	mCoth: mCoth,
	mSech: mSech,
	mCsch: mCsch,
	mError: mError,
	mErrorInverse: mErrorInverse,
	mFallingFactorial: mFallingFactorial,
	mRisingFactorial: mRisingFactorial,
	mHypergeometric: mHypergeometric,
	mHypergeometricDirect: mHypergeometricDirect,
	mBernouilliNumber: mBernouilliNumber,
	mAkiyamaTanigawaAlgorithm: mAkiyamaTanigawaAlgorithm,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	AddNumber: AddNumber,
	AddNumberRef: AddNumberRef,
	RemoveNumber: RemoveNumber,
	GetNumberRef: GetNumberRef,
	RemoveNumberRef: RemoveNumberRef,
	AddString: AddString,
	AddStringRef: AddStringRef,
	RemoveString: RemoveString,
	GetStringRef: GetStringRef,
	RemoveStringRef: RemoveStringRef,
	CreateDynamicArrayCharacters: CreateDynamicArrayCharacters,
	CreateDynamicArrayCharactersWithInitialCapacity: CreateDynamicArrayCharactersWithInitialCapacity,
	DynamicArrayAddCharacter: DynamicArrayAddCharacter,
	DynamicArrayCharactersIncreaseSize: DynamicArrayCharactersIncreaseSize,
	DynamicArrayCharactersDecreaseSizeNecessary: DynamicArrayCharactersDecreaseSizeNecessary,
	DynamicArrayCharactersDecreaseSize: DynamicArrayCharactersDecreaseSize,
	DynamicArrayCharactersIndex: DynamicArrayCharactersIndex,
	DynamicArrayCharactersLength: DynamicArrayCharactersLength,
	DynamicArrayInsertCharacter: DynamicArrayInsertCharacter,
	DynamicArrayCharacterSet: DynamicArrayCharacterSet,
	DynamicArrayRemoveCharacter: DynamicArrayRemoveCharacter,
	FreeDynamicArrayCharacters: FreeDynamicArrayCharacters,
	DynamicArrayCharactersToArray: DynamicArrayCharactersToArray,
	ArrayToDynamicArrayCharactersWithOptimalSize: ArrayToDynamicArrayCharactersWithOptimalSize,
	ArrayToDynamicArrayCharacters: ArrayToDynamicArrayCharacters,
	DynamicArrayCharactersEqual: DynamicArrayCharactersEqual,
	DynamicArrayCharactersToLinkedList: DynamicArrayCharactersToLinkedList,
	LinkedListToDynamicArrayCharacters: LinkedListToDynamicArrayCharacters,
	AddBoolean: AddBoolean,
	AddBooleanRef: AddBooleanRef,
	RemoveBoolean: RemoveBoolean,
	GetBooleanRef: GetBooleanRef,
	RemoveDecimalRef: RemoveDecimalRef,
	CreateLinkedListString: CreateLinkedListString,
	LinkedListAddString: LinkedListAddString,
	LinkedListStringsToArray: LinkedListStringsToArray,
	LinkedListStringsLength: LinkedListStringsLength,
	FreeLinkedListString: FreeLinkedListString,
	CreateLinkedListNumbers: CreateLinkedListNumbers,
	CreateLinkedListNumbersArray: CreateLinkedListNumbersArray,
	LinkedListAddNumber: LinkedListAddNumber,
	LinkedListNumbersLength: LinkedListNumbersLength,
	LinkedListNumbersIndex: LinkedListNumbersIndex,
	LinkedListInsertNumber: LinkedListInsertNumber,
	LinkedListSet: LinkedListSet,
	LinkedListRemoveNumber: LinkedListRemoveNumber,
	FreeLinkedListNumbers: FreeLinkedListNumbers,
	FreeLinkedListNumbersArray: FreeLinkedListNumbersArray,
	LinkedListNumbersToArray: LinkedListNumbersToArray,
	ArrayToLinkedListNumbers: ArrayToLinkedListNumbers,
	LinkedListNumbersEqual: LinkedListNumbersEqual,
	CreateLinkedListCharacter: CreateLinkedListCharacter,
	LinkedListAddCharacter: LinkedListAddCharacter,
	LinkedListCharactersToArray: LinkedListCharactersToArray,
	LinkedListCharactersLength: LinkedListCharactersLength,
	FreeLinkedListCharacter: FreeLinkedListCharacter,
	LinkedListCharactersAddString: LinkedListCharactersAddString,
	CreateDynamicArrayNumbers: CreateDynamicArrayNumbers,
	CreateDynamicArrayNumbersWithInitialCapacity: CreateDynamicArrayNumbersWithInitialCapacity,
	DynamicArrayAddNumber: DynamicArrayAddNumber,
	DynamicArrayNumbersIncreaseSize: DynamicArrayNumbersIncreaseSize,
	DynamicArrayNumbersDecreaseSizeNecessary: DynamicArrayNumbersDecreaseSizeNecessary,
	DynamicArrayNumbersDecreaseSize: DynamicArrayNumbersDecreaseSize,
	DynamicArrayNumbersIndex: DynamicArrayNumbersIndex,
	DynamicArrayNumbersLength: DynamicArrayNumbersLength,
	DynamicArrayInsertNumber: DynamicArrayInsertNumber,
	DynamicArrayNumberSet: DynamicArrayNumberSet,
	DynamicArrayRemoveNumber: DynamicArrayRemoveNumber,
	FreeDynamicArrayNumbers: FreeDynamicArrayNumbers,
	DynamicArrayNumbersToArray: DynamicArrayNumbersToArray,
	ArrayToDynamicArrayNumbersWithOptimalSize: ArrayToDynamicArrayNumbersWithOptimalSize,
	ArrayToDynamicArrayNumbers: ArrayToDynamicArrayNumbers,
	DynamicArrayNumbersEqual: DynamicArrayNumbersEqual,
	DynamicArrayNumbersToLinkedList: DynamicArrayNumbersToLinkedList,
	LinkedListToDynamicArrayNumbers: LinkedListToDynamicArrayNumbers,
	DynamicArrayNumbersIndexOf: DynamicArrayNumbersIndexOf,
	DynamicArrayNumbersIsInArray: DynamicArrayNumbersIsInArray,
	AddCharacter: AddCharacter,
	AddCharacterRef: AddCharacterRef,
	RemoveCharacter: RemoveCharacter,
	GetCharacterRef: GetCharacterRef,
	RemoveCharacterRef: RemoveCharacterRef,
	nCreateStringScientificNotationDecimalFromNumber: nCreateStringScientificNotationDecimalFromNumber,
	nCreateStringDecimalFromNumber: nCreateStringDecimalFromNumber,
	nCreateStringFromNumberWithCheck: nCreateStringFromNumberWithCheck,
	nGetMaximumDigitsForBase: nGetMaximumDigitsForBase,
	nGetFirstDigitPosition: nGetFirstDigitPosition,
	nGetSingleDigitCharacterFromNumberWithCheck: nGetSingleDigitCharacterFromNumberWithCheck,
	nGetDigitCharacterTable: nGetDigitCharacterTable,
	nCreateNumberFromDecimalStringWithCheck: nCreateNumberFromDecimalStringWithCheck,
	nCreateNumberFromDecimalString: nCreateNumberFromDecimalString,
	nCreateNumberFromStringWithCheck: nCreateNumberFromStringWithCheck,
	nCreateNumberFromParts: nCreateNumberFromParts,
	nExtractPartsFromNumberString: nExtractPartsFromNumberString,
	nGetNumberFromNumberCharacterForBase: nGetNumberFromNumberCharacterForBase,
	nCharacterIsNumberCharacterInBase: nCharacterIsNumberCharacterInBase,
	nStringToNumberArray: nStringToNumberArray,
	nStringToNumberArrayWithCheck: nStringToNumberArrayWithCheck,
	cCreateComplexNumber: cCreateComplexNumber,
	cCreatePolarComplexNumber: cCreatePolarComplexNumber,
	cAdd: cAdd,
	cAddToNew: cAddToNew,
	cSub: cSub,
	cSubToNew: cSubToNew,
	cMul: cMul,
	cMulToNew: cMulToNew,
	cDiv: cDiv,
	cDivToNew: cDivToNew,
	cConjugate: cConjugate,
	cConjugateToNew: cConjugateToNew,
	cAbs: cAbs,
	cArg: cArg,
	cCreatePolarFromComplexNumber: cCreatePolarFromComplexNumber,
	cCreateComplexFromPolar: cCreateComplexFromPolar,
	cRe: cRe,
	cIm: cIm,
	cAddPolar: cAddPolar,
	cAddPolarToNew: cAddPolarToNew,
	cSubPolar: cSubPolar,
	cSubPolarToNew: cSubPolarToNew,
	cMulPolar: cMulPolar,
	cMulPolarToNew: cMulPolarToNew,
	cDivPolar: cDivPolar,
	cDivPolarToNew: cDivPolarToNew,
	cSquareRoot: cSquareRoot,
	cPowerPolar: cPowerPolar,
	cPowerToNew: cPowerToNew,
	cPower: cPower,
	cNegate: cNegate,
	cAssignComplexByValues: cAssignComplexByValues,
	cAssignComplex: cAssignComplex,
	cEpsilonCompareComplex: cEpsilonCompareComplex,
	cExpComplex: cExpComplex,
	cSineComplex: cSineComplex,
	cCosineComplex: cCosineComplex,
	cComplexToString: cComplexToString,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfNumberArray: SwapElementsOfNumberArray,
	SwapElementsOfStringArray: SwapElementsOfStringArray,
	ReverseNumberArray: ReverseNumberArray,
	WriteStringToStingStream: WriteStringToStingStream,
	WriteCharacterToStingStream: WriteCharacterToStingStream,
	WriteBooleanToStingStream: WriteBooleanToStingStream,
	SubstringWithCheck: SubstringWithCheck,
	Substring: Substring,
	AppendString: AppendString,
	ConcatenateString: ConcatenateString,
	AppendCharacter: AppendCharacter,
	ConcatenateCharacter: ConcatenateCharacter,
	SplitByCharacter: SplitByCharacter,
	IndexOfCharacter: IndexOfCharacter,
	SubstringEqualsWithCheck: SubstringEqualsWithCheck,
	SubstringEquals: SubstringEquals,
	IndexOfString: IndexOfString,
	ContainsCharacter: ContainsCharacter,
	ContainsString: ContainsString,
	ToUpperCase: ToUpperCase,
	ToLowerCase: ToLowerCase,
	EqualsIgnoreCase: EqualsIgnoreCase,
	ReplaceString: ReplaceString,
	ReplaceCharacterToNew: ReplaceCharacterToNew,
	ReplaceCharacter: ReplaceCharacter,
	Trim: Trim,
	StartsWith: StartsWith,
	EndsWith: EndsWith,
	SplitByString: SplitByString,
	StringIsBefore: StringIsBefore,
	charToLowerCase: charToLowerCase,
	charToUpperCase: charToUpperCase,
	charIsUpperCase: charIsUpperCase,
	charIsLowerCase: charIsLowerCase,
	charIsLetter: charIsLetter,
	charIsNumber: charIsNumber,
	charIsWhiteSpace: charIsWhiteSpace,
	charIsSymbol: charIsSymbol,
	charCharacterIsBefore: charCharacterIsBefore,
	charDecimalDigitToCharacter: charDecimalDigitToCharacter,
	charCharacterToDecimalDigit: charCharacterToDecimalDigit,
	test: test
};